unit Canvas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, ActnList, Menus, ExtCtrls, ExtDlgs,
  StdCtrls, ExtActns, StdActns, Jpeg;

type
  TF_Canvas = class(TForm)
    ScrollBox1: TScrollBox;
    C_Canvas: TImage;

    C_ImageList: TImageList;
    C_ActionList: TActionList;
    FileNew1: TAction;
    FileOpen1: TFileOpen;
    OpenPicture1: TOpenPicture;
    FileSave1: TAction;
    FileSaveAs1: TFileSaveAs;
    SavePicture1: TAction;
    SaveAsPicture1: TSavePicture;
    FileExit1: TFileExit;

    C_Menu: TMainMenu;
    Files1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Open2: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Save2: TMenuItem;
    SaveAs2: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;

    C_ToolBar: TToolBar;
    Tool_FN: TToolButton;
    Tool_FO: TToolButton;
    Tool_FOP: TToolButton;
    Tool_FS: TToolButton;
    Tool_FSP: TToolButton;
    ToolDiv1: TToolButton;
    Tool_VGrid: TToolButton;
    ToolButton2: TToolButton;

    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure OpenPicture1Accept(Sender: TObject);
    procedure SaveAsPicture1Accept(Sender: TObject);
    procedure SavePicture1Execute(Sender: TObject);
    procedure CompoundLayer;
    procedure Tool_VGridClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Public 錾 }

    _Layer  : Array of TBitmap; // C[
    _Compo  : Array[0..1] of TBitmap; // 摜 0:Obh 1:ObhL@

//    _ChipArray : Array of Array of Integer; // `bvzuۑp
  end;

var
  F_Canvas: TF_Canvas;

  CurrentFile : String;
  
//  _CCursor : TBitmap; // J[\`p

implementation

uses Grid;
//uses Grid, Palette;

{$R *.dfm}

procedure TF_Canvas.WMEraseBkgnd(var m : TWMEraseBkgnd);
begin
  m.Result := LRESULT(False); // ĕ`掞̂}鏈B炵B
end;                          // twvATBitmap ibmpformu.pasj

procedure TF_Canvas.FormCreate(Sender: TObject);
var
  i : Integer;
begin
// pBitmap̏ݒ
  SetLength(_Layer, 1);
  _Layer[0] := TBitmap.Create;
  for i:= 0 to 1 do
  begin
    _Compo[i] := TBitmap.Create;
  end;
end;

procedure TF_Canvas.OpenPicture1Accept(Sender: TObject);
var
  _ImgChk : TImage; // JPEG摜̕ϊp

  i : Integer;
begin
  CurrentFile := OpenPicture1.Dialog.FileName; // 摜t@Cl

  _ImgChk := TImage.Create(Self);
  _ImgChk.Picture.LoadFromFile(CurrentFile); // 摜t@Cǂݍ JPEGOK
  _Layer[0].Assign(_ImgChk.Picture.Graphic); // ǂݍ񂾉摜Bitmapɕϊ[
  _Layer[0].PixelFormat := pf24bit; // FtJ[ɕϊ 
  _ImgChk.Free;

//  _Layer[0].LoadFromFile(CurrentFile); ɂJPEG摜̓ǂݍݎɃG[

  C_Canvas.Width  := _Layer[0].Width;  // \pR|[lg̑傫ݒ
  C_Canvas.Height := _Layer[0].Height;

  C_Canvas.Picture.Bitmap.Width  := _Layer[0].Width;  // \p摜̑傫ݒ
  C_Canvas.Picture.Bitmap.Height := _Layer[0].Height;

  for i:= 0 to 1 do
  begin
    _Compo[i].Width  := _Layer[0].Width;  // p摜̑傫ݒ
    _Compo[i].Height := _Layer[0].Height;
  end;

  F_Grid._CGLine.Width  := _Layer[0].Width;  // Obh}XN摜̑傫ݒ
  F_Grid._CGLine.Height := _Layer[0].Height;
  F_Grid._CGrid.Width   := _Layer[0].Width;  // Obhp摜̑傫ݒ
  F_Grid._CGrid.Height  := _Layer[0].Height;

  F_Grid.DrawGLine; // I𒆂̃Obh`
end;

procedure TF_Canvas.SaveAsPicture1Accept(Sender: TObject);
begin
  CurrentFile := SaveAsPicture1.Dialog.FileName; // t@C擾
  SavePicture1.OnExecute(Sender); // ȍ~͏㏑ۑƓ
end;

procedure TF_Canvas.SavePicture1Execute(Sender: TObject);
var
  _Msg_Save   : String; // ㏑mFbZ[W
  _FiletoFind : String; // t@Č
  _Ext        : String; // t@C̊gq
  _JPG        : TJpegImage; // 摜Jpegϊp

  i : Integer;
begin
  _Msg_Save := '㏑܂B낵łH';

  _FileToFind := FileSearch(CurrentFile, GetCurrentDir); // t@C̗LmF
  if (_FileToFind = '') or // t@C݂ȂꍇA܂͏㏑OK̏ꍇ
    (MessageDlg(_Msg_Save, mtConfirmation, mbOKCancel, 0) = mrOK) then
  begin
    if (F_Grid.Check_Grid.Checked) then // Obhtŉ摜ۑꍇ
      i := 1  // _Compo[1]I
    else // ObhȂŉ摜ۑꍇ
      i := 0; // _Compo[0]I
    _Ext := AnsiLowerCase(ExtractFileExt(CurrentFile)); // gq擾
    if (_Ext = '.jpg') or (_Ext = '.jpeg') then // gqJPEG摜Ȃ
    begin
      _JPG := TJpegImage.Create;
      _JPG.Assign(_Compo[i]); // 摜JPEGɕϊ
      _JPG.SaveToFile(CurrentFile); // ϊ摜ۑ
      _JPG.Free;
    end
    else
    begin
      if _Ext = '' then // gqȂ
        CurrentFile := CurrentFile + '.bmp'; // gqt
      _Compo[i].SaveToFile(CurrentFile); // 摜ۑ
    end;
  end
  else // t@C݂A㏑sȂ
    SaveAsPicture1.ExecuteTarget(Sender); // VKۑƓ
end;

procedure TF_Canvas.CompoundLayer;
//var
//  _Rect : TRect;
begin
// Obh̕\}ƓɁA
// pbgAObhAJ[\摜̍ōsB
//
  _Compo[0].Assign(_Layer[0]); // wi摜p摜

  _Compo[1].Assign(_Compo[0]); // SC[摜ObhL摜փRs[

//  _Rect := Rect(0, 0, _Compo[1].Width, _Compo[1].Height); // Obh͈̔
//  _Compo[1].Canvas.CopyMode := cmMergePaint; // Obh𔒂
//  _Compo[1].Canvas.CopyRect(_Rect, F_Grid._CGLine.Canvas,  _Rect);
//  _Compo[1].Canvas.CopyMode := cmSrcAnd; // ObhȊOObh摜ƍ
//  _Compo[1].Canvas.CopyRect(_Rect, F_Grid._CGColor.Canvas, _Rect);

  BitBlt(  _Compo[1].Canvas.Handle,0,0,_Compo[1].Width,_Compo[1].Height,
      F_Grid._CGLine.Canvas.Handle,0,0,
         MERGEPAINT); // Obh𔒂
  BitBlt(  _Compo[1].Canvas.Handle,0,0,_Compo[1].Width,_Compo[1].Height,
       F_Grid._CGrid.Canvas.Handle,0,0,
         SRCAND);  // ObhȊOObh摜ƍ

//  BitBlt WinAPỈ摜߁B
//  Ă邱ƂCopyMode+CopyRectƓB
//  http://yokohama.cool.ne.jp/chokuto/urawaza/api/BitBlt.html
//  http://hp.vector.co.jp/authors/VA011889/delphi/mask.htm

  C_Canvas.Picture.Assign(_Compo[1]); // ObhL摜\
end;

procedure TF_Canvas.Tool_VGridClick(Sender: TObject);
begin
  F_Grid.Visible := Tool_VGrid.Down;
end;

procedure TF_Canvas.ToolButton2Click(Sender: TObject);
begin
//  Form_Palette.Visible := ToolButton2.Down;
end;

end.
