unit Grid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ImgList, ToolWin, ComCtrls,
  ActnList;

type
  TF_Grid = class(TForm)
    L_Type01:     TLabel;
    G_ActionList: TActionList;
    G_ImageList:  TImageList;
    Grid_Nothing: TAction;
    Grid_Square:  TAction;
    Grid_HexH:    TAction;
    Grid_HexV:    TAction;
    Grid_Diamond: TAction;
    GridButtons:  TPanel;
    Btn_Nothing:  TSpeedButton;
    Btn_Square:   TSpeedButton;
    Btn_HexH:     TSpeedButton;
    Btn_HexV:     TSpeedButton;
    Btn_Diamond:  TSpeedButton;
    Check_Grid:   TCheckBox;

    Bevel1: TBevel;

    L_Size01: TLabel;
    L_Size02: TLabel;
    L_Size03: TLabel;
    L_Size04: TLabel;
    L_Size05: TLabel;
    E_SizeH:  TEdit;
    E_SizeV:  TEdit;

    L_Length02: TLabel;
    L_Length03: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;

    Bevel2: TBevel;

    L_Color01:  TLabel;
    L_Color02:  TLabel;
    L_Color03:  TLabel;
    L_Color04:  TLabel;
    ColorPanel: TPanel;
    ColorBarR:  TScrollBar;
    ColorBarG:  TScrollBar;
    ColorBarB:  TScrollBar;
    E_ColorR:   TEdit;
    E_ColorG:   TEdit;
    E_ColorB:   TEdit;

    Bevel3: TBevel;
    Btn_SHexH: TSpeedButton;
    Btn_SHexV: TSpeedButton;
    Grid_SHexH: TAction;
    Grid_SHexV: TAction;
    ColorDialog1: TColorDialog;
    procedure KeyPressLimit(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GridTypeExecute(Sender: TObject);
    procedure DrawGLine;
    procedure DrawGrid;
    procedure DrawSquare(_GWidth: Integer; _GHeight: Integer);
    procedure DrawDiamond(_GWidth: Integer; _GHeight: Integer);
    procedure DrawSHexH(_GWidth: Integer; _GHeight: Integer);
    procedure DrawSHexV(_GWidth: Integer; _GHeight: Integer);
    procedure DrawHexH(_GWidth: Integer; _GHeight: Integer);
    procedure DrawHexV(_GWidth: Integer; _GHeight: Integer);
    procedure GridSizeChange(Sender: TObject);
    procedure ColorBarChange(Sender: TObject);
    procedure E_ColorChange(Sender: TObject);
    procedure ColorPanelClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    _CGLine : TBitmap; // Form_Canvas ̃Obh`pî݁j
    _CGrid  : TBitmap; // Form_Canvas ̃Obh`p

    _GMode  : Integer; // I𒆂̃ObhE^Cv ImageListIndexl

    _GridW, _GridH: Integer; // Obhƍ
  end;

var
  F_Grid: TF_Grid;

implementation

uses Canvas;
//uses Canvas, Palette;

{$R *.dfm}

procedure TF_Grid.KeyPressLimit(Sender: TObject; var Key: Char);
begin
  if (Key = #13) then // ̓L[EnterȂ
    TEdit(Sender).OnExit(Sender) // lm菈
  else if not (Key in ['0'..'9', #08]) then // ̓L['0'`'9',BackSpace/Delete ȊOȂ
  begin
    Key := #0; // ͂𖳎
    beep;
  end;
end;

procedure TF_Grid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  F_Canvas.Tool_VGrid.Down := False; // F_Canvasɂ\{^𐧌
end;

procedure TF_Grid.FormCreate(Sender: TObject);
begin
  _CGLine := TBitmap.Create; // Obhprbg}bv
  _CGLine.Monochrome := True; // mNpɂ
  _CGLine.PixelFormat := pf1bit; // 2Fɂ
  _CGLine.Transparent := False; // Ȃ
  _CGLine.Canvas.Brush.Color := clWhite; // wiF͔
  _CGLine.Canvas.Pen.Color := clBlack; // ̐F͍

  _CGrid := TBitmap.Create; // ObhFprbg}bv
  _CGrid.PixelFormat := pf24bit;
  _CGrid.Transparent := False; // Ȃ
  _CGrid.Canvas.Brush.Color := clBlack; // F

  _GMode := 0; // ObhE^CvI{^̏Ԃɍ킹

  _GridW := StrToInt(E_SizeH.Text); // ObhEditBox̏Ԃɍ킹
  _GridH := StrToInt(E_SizeV.Text); // ObhEditBox̏Ԃɍ킹
end;

procedure TF_Grid.GridTypeExecute(Sender: TObject);
begin
  _GMode := TAction(Sender).ImageIndex; // ObhE^Cv擾
  DrawGLine; // ObhύX
end;

procedure TF_Grid.DrawGLine;
var
  _Rect : TRect;
begin
  _Rect := Rect(0, 0,
    F_Canvas.C_Canvas.Width, F_Canvas.C_Canvas.Height); // 摜̈ݒ

  with _CGLine do // Obh`̓ꊇ
  begin
    Width  := F_Canvas.C_Canvas.Width;  // `̈敝ݒ
    Height := F_Canvas.C_Canvas.Height; // `̈捂ݒ

    Canvas.FillRect(_Rect); // ShԂ

    case _GMode of // w肳ꂽ`̃Obh`
      2: DrawSquare (_GridW, _GridH);
      3: DrawDiamond(_GridW, _GridH);
      4: DrawSHexH  (_GridW, _GridH);
      5: DrawSHexV  (_GridW, _GridH);
      6: DrawHexH   (_GridW, _GridH);
      7: DrawHexV   (_GridW, _GridH);
    else
      begin
//        SetLength(Form_Canvas._ChipArray,    1); // `bvzu
//        SetLength(Form_Canvas._ChipArray[0], 1);
      end;
    end;
  end;

  DrawGrid; // Obh`
end;

procedure TF_Grid.DrawGrid;
begin
  _CGrid.Canvas.FillRect(
    Rect(0, 0,
    F_Canvas.C_Canvas.Width, F_Canvas.C_Canvas.Height) );

  BitBlt(_CGrid.Canvas.Handle,0,0,_CGrid.Width,_CGrid.Height,
        _CGLine.Canvas.Handle,0,0,
         SRCPAINT); // ObhȊO𔒂

  F_Canvas.CompoundLayer;
end;

procedure TF_Grid.DrawSquare(_GWidth: Integer; _GHeight: Integer);
var
  _H, _V : Integer;
  _x, _y : Integer;
  _i     : Integer;
begin
  with _CGLine do // Obh\pIuWFNg̏ꊇ
  begin
    _H := Trunc(Width  / _GWidth ) + 1; // ̌JԂ 
    _V := Trunc(Height / _GHeight) + 1; // ̌JԂ 

    for _i := 1 to _H do // 
    begin
      _x := _i * _GWidth - 1;
      Canvas.MoveTo(_x, 0);
      Canvas.LineTo(_x, Height);
    end;
    for _i := 1 to _V do // 
    begin
      _y := _i * _GHeight - 1;
      Canvas.MoveTo(0,     _y);
      Canvas.LineTo(Width, _y);
    end;
  end;

//    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
//  for _i := 0 to _H - 2 do
//    SetLength(Form_Canvas._ChipArray[_i], _V - 1);
end;

procedure TF_Grid.DrawDiamond(_GWidth: Integer; _GHeight: Integer);
var
  _H,  _V  : Integer;
  _X,  _Y  : Integer;
  _xx, _yy : Integer;

  _i: Integer;
begin
  with _CGLine do
  begin
    _H := Trunc((Width  - (_GWidth  / 2)) / _GWidth ) + 1;
    _V := Trunc((Height - (_GHeight / 2)) / _GHeight) + 1;

    _X := (_H + 1) * _GWidth;
    _Y := (_V + 1) * _GHeight;

    _xx := Trunc(_GWidth  / 2 + 0.5);
    _yy := Trunc(_GHeight / 2 + 0.5);

    for _i := 0 to _H do
    begin
      Canvas.MoveTo(_xx + _GWidth * (_i + _V + 1), _Y); // _ tXbVi㔼j
      Canvas.LineTo(_xx + _GWidth *  _i, 0);

//      Canvas.MoveTo(_xx + _GWidth *  _i, 0); // ^ XbVi㔼j
      Canvas.LineTo(0, _yy + _GHeight * _i);
    end;
    for _i := 0 to _V do
    begin
      Canvas.MoveTo(0,  _yy + _GHeight *  _i); // _ tXbVij
      Canvas.LineTo(_X, _yy + _GHeight * (_H + 1 + _i));

      Canvas.MoveTo(_X, _yy + _GHeight * (_V - _i)); // ^ XbVij
      Canvas.LineTo(_xx + _GWidth * (_H - _i), _Y);
    end;
  end;

//    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
//  for _i := 0 to _H - 2 do
//    SetLength(Form_Canvas._ChipArray[_i], _V - 1); // sSB
end;

procedure TF_Grid.DrawSHexH(_GWidth: Integer; _GHeight: Integer);
var
  _H, _V : Integer;
  _x, _y : Integer;
  _i, _j : Integer;
begin
  with _CGLine do // Obh\pIuWFNg̏ꊇ
  begin
    _H := Trunc(Width  / _GWidth ) + 1; // ̌JԂ 
    _V := Trunc(Height / _GHeight) + 1; // ̌JԂ 

    for _j := 0 to Trunc(_V / 2) do
    begin
      for _i := 1 to _H do // iij
      begin
        _x := _i * _GWidth - 1;
        Canvas.MoveTo(_x, _GridH * (_j * 2 + 0));
        Canvas.LineTo(_x, _GridH * (_j * 2 + 1));
      end;
      for _i := 1 to _H do // iij
      begin
        _x := _i * _GWidth - 1 - Trunc((_GridW / 2) + 0.5);
        Canvas.MoveTo(_x, _GridH * (_j * 2 + 1));
        Canvas.LineTo(_x, _GridH * (_j * 2 + 2));
      end;
    end;
    for _i := 1 to _V do // 
    begin
      _y := _i * _GHeight - 1;
      Canvas.MoveTo(0,     _y);
      Canvas.LineTo(Width, _y);
    end;
  end;

//    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
//  for _i := 0 to _H - 2 do
//    SetLength(Form_Canvas._ChipArray[_i], _V - 1);
end;

procedure TF_Grid.DrawSHexV(_GWidth: Integer; _GHeight: Integer);
var
  _H, _V : Integer;
  _x, _y : Integer;
  _i, _j : Integer;
begin
  with _CGLine do // Obh\pIuWFNg̏ꊇ
  begin
    _H := Trunc(Width  / _GWidth ) + 1; // ̌JԂ 
    _V := Trunc(Height / _GHeight) + 1; // ̌JԂ 

    for _i := 1 to _H do // 
    begin
      _x := _i * _GWidth - 1;
      Canvas.MoveTo(_x, 0);
      Canvas.LineTo(_x, Height);
    end;
    for _j := 0 to Trunc(_H / 2) do
    begin
      for _i := 1 to _V do // ij
      begin
        _y := _i * _GHeight - 1;
        Canvas.MoveTo(_GridW * (_j * 2 + 0), _y);
        Canvas.LineTo(_GridW * (_j * 2 + 1), _y);
      end;
      for _i := 1 to _V do // ij
      begin
        _y := _i * _GHeight - 1 - Trunc((_GridH / 2) + 0.5);
        Canvas.MoveTo(_GridW * (_j * 2 + 1), _y);
        Canvas.LineTo(_GridW * (_j * 2 + 2), _y);
      end;
    end;
  end;

//    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
//  for _i := 0 to _H - 2 do
//    SetLength(Form_Canvas._ChipArray[_i], _V - 1);
end;

procedure TF_Grid.DrawHexH(_GWidth: Integer; _GHeight: Integer);
var
  _Wsqrt3 : Single;

  _X : array[0..2] of Integer;
  _Y : array[0..4] of Integer;

  _H,  _V  : Integer;
  _xx, _yy : Integer;
  _i,  _j  : Integer;
begin
  _Wsqrt3 := _GWidth * 0.25 * sqrt(3);

  _X[0] := Trunc(_GWidth * 0.5 + 0.5 - _Wsqrt3); // AutoREALM ̃Obh`Ql
  _X[1] := Trunc(_GWidth * 0.5 + 0.5);
  _X[2] := Trunc(_GWidth * 0.5 + 0.5 + _Wsqrt3); //     1,0
                                                 // 0,1 ^_ 2,1
  _Y[0] := 0;                                    //    b
  _Y[1] := Trunc(_GHeight * 0.25 + 0.5);         // 0,2 _^ 2,2
  _Y[2] := Trunc(_GHeight * 0.75 + 0.5);         //     1,3
  _Y[3] :=       _GHeight;                       //      b
  _Y[4] := Trunc(_GHeight * 1.5  + 0.5);         //     1,4

  _H := Trunc( _CGLine.Width / _WSqrt3 / 2); // JԂ 
  _V := Trunc((_CGLine.Height - _GHeight) / _GHeight / 1.5) + 1; // JԂ 

  for _j := 0 to _V do // ɌJԂ
  begin
    _yy := Trunc(_j * _GHeight * 1.5 + 0.5);
    for _i := 0 to _H do // ɌJԂ
    begin
      _xx := Trunc(_i * _Wsqrt3 * 2 - _GWidth * 0.5 + _Wsqrt3 + 0.5) - 1;
      _CGLine.Canvas.Polyline([
        Point(_X[2] + _xx, _Y[1] + _yy), // iN_
        Point(_X[1] + _xx, _Y[0] + _yy), // E
        Point(_X[0] + _xx, _Y[1] + _yy), // 
        Point(_X[0] + _xx, _Y[2] + _yy), // 
        Point(_X[1] + _xx, _Y[3] + _yy), // 
        Point(_X[2] + _xx, _Y[2] + _yy)]); // E
      _CGLine.Canvas.MoveTo(_X[1] + _xx, _Y[3] + _yy); // iN_
      _CGLine.Canvas.LineTo(_X[1] + _xx, _Y[4] + _yy); // 
    end;
  end;

//  _j := Trunc((_CGLine.Height - _GHeight) / _GHeight / 0.75) + 1;
//    SetLength(F_Canvas._ChipArray, _H); // `bvpz
//  for _i := 0 to _H - 2 do
//    SetLength(Form_Canvas._ChipArray[_i], _j);
end;

procedure TF_Grid.DrawHexV(_GWidth: Integer; _GHeight: Integer);
var
  _Hsqrt3 : Single;

  _X : array[0..4] of Integer;
  _Y : array[0..3] of Integer;

  _H,  _V  : Integer;
  _xx, _yy : Integer;
  _i,  _j  : Integer;
begin
  _Hsqrt3 := _GHeight * 0.25 * sqrt(3); // DrawHexH ̐Ɛւ

  _X[0] := 0;
  _X[1] := Trunc(_GWidth * 0.25 + 0.5);
  _X[2] := Trunc(_GWidth * 0.75 + 0.5);
  _X[3] := _GWidth;
  _X[4] := Trunc(_GWidth * 1.5  + 0.5);

  _Y[0] := Trunc(_GHeight * 0.5 + 0.5 - _Hsqrt3);
  _Y[1] := Trunc(_GHeight * 0.5 + 0.5);
  _Y[2] := Trunc(_GHeight * 0.5 + 0.5 + _Hsqrt3);
  _Y[3] := Trunc(                 0.5 + _Hsqrt3);

  _H := Trunc((_CGLine.Width - _GWidth) / _GWidth / 1.5) + 1; // JԂ 
  _V := Trunc( _CGLine.Height / _HSqrt3 / 2); // JԂ 

  for _j := 0 to _H do // ɌJԂ
  begin
    _xx := Trunc(_j * _GWidth * 1.5 + 0.5);
    for _i := 0 to _V do // ɌJԂ
    begin
      _yy := Trunc(_i * _Hsqrt3 * 2 - _GHeight * 0.5 + _Hsqrt3 + 0.5) - 1;
      _CGLine.Canvas.Polyline([
        Point(_X[1] + _xx, _Y[2] + _yy), // sN_
        Point(_X[0] + _xx, _Y[1] + _yy), // 
        Point(_X[1] + _xx, _Y[0] + _yy), // 
        Point(_X[2] + _xx, _Y[0] + _yy), // 㒆
        Point(_X[3] + _xx, _Y[1] + _yy), // E
        Point(_X[2] + _xx, _Y[2] + _yy)]); // E
      _CGLine.Canvas.MoveTo(_X[3] + _xx, _Y[1] + _yy); // sN_
      _CGLine.Canvas.LineTo(_X[4] + _xx, _Y[1] + _yy); // E
    end;
  end;

//  _j := Trunc((_CGLine.Width - _GWidth) / _GWidth / 0.75) + 1;
//    SetLength(Form_Canvas._ChipArray, _j); // `bvpz
//  for _i := 0 to _j - 1 do
//    SetLength(Form_Canvas._ChipArray[_i], _V);
end;

procedure TF_Grid.GridSizeChange(Sender: TObject);
begin
  _GridW := StrToInt(E_SizeH.Text); // VObhIntegerŊm
  _GridH := StrToInt(E_SizeV.Text); // VObhIntegerŊm

  DrawGLine; // LoX̃ObhύX

//  Form_Palette.GridLineDraw; // pbg̃ObhύX
//  Form_Palette.FreeChip(Sender); // `bvI\
////  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TF_Grid.ColorBarChange(Sender: TObject);
var
  _R, _G, _B : Integer;
begin
  _R := ColorBarR.Position; // XN[o[̈ʒul
  _G := ColorBarG.Position;
  _B := ColorBarB.Position;

  E_ColorR.Text := IntToStr(_R); // EditBoxɔf
  E_ColorG.Text := IntToStr(_G);
  E_ColorB.Text := IntToStr(_B);

  ColorPanel.Color := RGB(_R, _G, _B); // \FύX
  _CGrid.Canvas.Brush.Color := RGB(_R, _G, _B); // Obh`FύX

  DrawGrid; // LoX̃ObhFύX

//  Form_Palette.GridLineDraw; // pbg̃ObhύX
//  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TF_Grid.E_ColorChange(Sender: TObject);
var
  _R, _G, _B : Integer;
begin
  if TEdit(Sender).Text = '' then
    TEdit(Sender).Text := '0'
  else if StrToInt(TEdit(Sender).Text) > 255 then
  begin
    TEdit(Sender).Text := '255';
    beep;
  end;
  _R := StrToInt(E_ColorR.Text); // EditBox̒ll
  _G := StrToInt(E_ColorG.Text);
  _B := StrToInt(E_ColorB.Text);

  ColorBarR.Position := _R; // XN[o[ɔf
  ColorBarG.Position := _G;
  ColorBarB.Position := _B;

  ColorPanel.Color := RGB(_R, _G, _B); // \FύX
  _CGrid.Canvas.Brush.Color := RGB(_R, _G, _B); // Obh`FύX

  DrawGrid; // LoX̃ObhύX

//  Form_Palette.GridLineDraw; // pbg̃ObhύX
//  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TF_Grid.ColorPanelClick(Sender: TObject);
var
  _R, _G, _B : Integer;
begin
  if ColorDialog1.Execute then
  begin
    _B := Trunc(ColorDialog1.Color / $10000); // ColorDialog1Ŏ擾F𕪉
    _G := Trunc((ColorDialog1.Color - _B * $10000) / $100);
    _R := ColorDialog1.Color - (_B * $10000) - (_G * $100);

    E_ColorR.Text := IntToStr(_R); // FwpEditBoxɐli[
    E_ColorG.Text := IntToStr(_G);
    E_ColorB.Text := IntToStr(_B);
    E_ColorChange(E_ColorB); // i[l𔽉f
  end;
end;

end.
